# Sqlmap Attacks

Sends sql injection attacks with sqlmap. 
At [Sql Injection](sqlinjections/SQLInjections.md) you can find more information about Sql Injection and examples of logfile for DVWA vulnerable site. 

## Sqlmap 

Varing the subtype executes different type of attacks by  choosing different levels and risks values will generate different attacks. In addition, the technique can be choosed by changing the 'techniques' parameter, it can take the following values:    
- B: Boolean-based blind     
- E: Error-based    
- U: Union query-based   
- S: Stacked queries     
- T: Time-based blind    
- Q: Inline queries     

You can choose different combinations of those values.

## Environment variables

**Generate specific attack type:** The attack.list contains the environment variables for an specific attack.  

```bash 
	DVWA_URL:  Url to attack
	USERNAME:  Username for the website
	PASSWORD:  Password for the website
	LEVEL:     SQLMAP level - the number of payloads to be performed (1..5)
	RISK:      SQLMAP risk - type of payloads  (1..3) 
	TECHNIQUE: Combinations of techniques to use (BEUSTQ) 
	USERS:     Amount of users in the system to attack
	MODE:      Mode for DVWA website (low, medium, high, impossible) 
	ATTACK_TYPE: Type of SQLMAP injection (all, blind_injection, dump)
```
**Generate multiples attacks:** The env.list contains the environment variables for generating multiple attacks.   
       
```bash 
	DVWA_URL: Url to attack
	USERNAME: Username for the website
	PASSWORD: Password for the website
	CONTEXT: Docker context to run the containers 
	LEVEL: List of numbers separated by commas that indicates the sqlmap levels to use. For example if you want to use level 2 and 3 the value for this variable would be: 2,3 
	RISK: List of numbers separated by commas that indicates the sqlmap risks to use.
	MODE: List of modes for DVWA site separated by commas: low,medium,high,impossible
	ATTACK_TYPE: List of sqlmap attack types to use: all,blind_injection,dump
	TECHNIQUE: String that indicates the different techniques to be used: BEUSTQ
	FIXED: indicates that the techniques used should not be combined separetly. 
	USERS: Amount of users in the system to attack
```

In order to run the attacks the DVWA server should be up:

```bash 
	docker run -dit -p 8081:80 --network=dvwa aracloud/docker-dvwa 
```

You can access the website at [http://localhost:8081](http://localhost:8081)

Get the network alias 
```bash 
	docker inspect {container_id}
```

## Run specific attack

Edit attack.list file with the desired parameters; setting the url with the hostname obtained for the network
```bash 
	docker build -t sqlmap .
```

```bash 
	docker run -d --env-file attack_B.list --name sqlmap-attack --network dvwa sqlmap
```

## Run multiple attacks

Edit env.list file with the desired parameters  

```bash 
	run_attacks.sh 
```

## Check logs 
```bash 
	docker logs {DOCKER_ID}
```