#!/usr/bin/python

import itertools
import os
import time

docker_context = os.getenv('CONTEXT', 'default')
level = os.getenv('LEVEL', '1,2,3,4,5').split(',')
risk = os.getenv('RISK', '1,2,3').split(',')
mode = os.getenv('MODE', 'low,medium,high,impossible').split(',')
attack_type = os.getenv('ATTACK_TYPE', 'all,blind_injection,dump').split(',')
technique = os.getenv('TECHNIQUE', 'BEUSTQ')
dvwa_url = os.getenv('DVWA_URL', 'http://localhost:80')
username = os.getenv('USERNAME', 'admin')
password = os.getenv('PASSWORD', 'password')
users = os.getenv('USERS', '5')
fixed = bool(os.getenv('FIXED', 'False'))

techniques = [technique]
if not fixed:
	for i range(1, len(technique):
		combinations = ''.join(list(itertools.combinations(technique, i)))
		techniques.append(combinations)

params_combinations = list(itertools.product(level, risk, mode, attack_type, techniques))


for p in params_combinations:
	container_name = 'sqlmap-level{0[0]}-risk{0[1]}-mode{0[2]}-{0[3]}-{0[4]}'.format(p)
	filename = '{}_env.list'.format(container_name)
	env_file = open(filename, "w")

	env_file.writelines(['DVWA_URL={}\n'.format(dvwa_url),'USERNAME={}\n'.format(username), 
			'PASSWORD=password\n'.format(password), 
			'LEVEL={0[0]}\n'.format(p), 'RISK={0[1]}\n'.format(p), 
			'TECHNIQUE={0[4]}\n'.format(p), 'USERS={}\n',format(users),
			'MODE={0[2]}\n'.format(p), 'ATTACK_TYPE={0[3]}\n'.format(p)])

	env_file.close()

	output1 = subprocess.call(['docker', \
		                      '--context',\
	                          'run', '-d', '-v', \
	                          'attacks-sqlmap/{}:/var/log/apache2/'.format(container_name),
	                          '--name dvwa-{}'.format(container_name),\
	                           '-p', '80:80', \
	                           'aracloud/docker-dvwa'])

	time.sleep(240 seconds)

  	output = subprocess.call(['docker', '-- context', docker_context, \
                    'run', '-d', \
                    '--env-file', 'filename', \
                    '--name', 'container_name', \
                    'mikaelapisani/sqlmap:latest']
                    )

